#include "configure.h"
#include <stdio.h>
#include <X11/Xutil.h>

void OnConfigureRequest(const XConfigureRequestEvent* e) {
	  XWindowChanges changes;
	  printf("XConfigureRequestEvent %lu\n", e->window);
	  printf("\tx = %i\n", e->x);
	  printf("\ty = %i\n", e->y);
	  printf("\tw = %i\n", e->width);
	  printf("\th = %i\n", e->height);


	  {
		  XTextProperty text_property;
		  XGetWMName(e->display, e->window, &text_property);
		  printf("\tname: %s\n", text_property.value);
	  }
	  {
		  XClassHint class;
		  XGetClassHint(e->display, e->window, &class);
		  printf("\tclass: %s, %s\n", class.res_class, class.res_name);
	  }

	  int screen_number = XDefaultScreen(e->display);
	  int full_width = XDisplayWidth(e->display, screen_number);
	  int full_height = XDisplayWidth(e->display, screen_number);

	  // Copy fields from e to changes.
	  changes.x = 0;
	  changes.y = 0;
	  changes.width = full_width;
	  changes.height = full_height;
	  changes.border_width = e->border_width;
	  changes.sibling = e->above;
	  changes.stack_mode = e->detail;
	  // Grant request by calling XConfigureWindow().
	  XConfigureWindow(e->display, e->window, e->value_mask, &changes);
}
