#include <X11/Xlib.h>
#include "create.h"
#include "configure.h"
#include "map.h"
#include "reparent.h"
#include "destroy.h"

Display *display;
Window root;

int main(int argc, char** argv) {
	display = XOpenDisplay(NULL);

	root = DefaultRootWindow(display);

	XSelectInput(display, root, SubstructureRedirectMask | SubstructureNotifyMask);
	XSync(display, 0);

	for (;;) {
		XEvent e;
		XNextEvent(display, &e);

		switch(e.type) {
			case CreateNotify:
				OnCreateNotify(&e.xcreatewindow);
				break;
			case ConfigureRequest:
				OnConfigureRequest(&e.xconfigurerequest);
				break;
			case MapRequest:
				OnMapRequest(root, &e.xmaprequest);
				break;
			case DestroyNotify:
				OnDestroyNotify(&e.xdestroywindow);
				break;
			case ReparentNotify:
				OnReparentNotify(&e.xreparent);
				break;
			default:
				break;
					/* LOG(WARNING) << "Ignored event"; */
		}
	}

	XCloseDisplay(display);
}
